body {
    height: 100vh;
    background: #111;
    display: flex;
    justify-content: center;
    align-items: center;
}

h1 {
    margin: 0;
    padding: 0;
    font-size: 60px;
    color: #CCC;
    text-transform: uppercase;
    letter-spacing: 10px;
    position: relative;
}

h1::before {
    content: attr(data-text);
    position: absolute;
    top: 0;
    left: 0;
    width: 50%;
    color: #5500FF;
    letter-spacing: 10px;
    overflow: hidden;
    border-right: 4px solid #5500FF;

    animation: hover 2s linear infinite;
}

@keyframes hover {

    0%,
    100% {
        width: 0;
    }

    50% {
        width: 100%;
    }
}